from datetime import datetime

from meteoapi.app.dataclasses import DataFormat
from meteoapi.app.dataclasses import Dataset
from meteoapi.app.dataclasses import Location
from meteoapi.app.dataclasses import Project

EXAMPLE_PROJECTS = [
    Project(
        'Project A',
        [
            Location(
                "Mast EMD", 9.9888, 57.0129, 25.0,
                [
                    Dataset(
                        1, "Rev. 1", "Raw data (windPRO meteo export)", 90.5,
                        datetime(2012, 12, 31), datetime(2019, 12, 31),
                        datetime(2023, 1, 5, 12, 24), "John Stone",
                        datetime(2023, 1, 13, 10, 49), "John Stone",
                        DataFormat.WINDPRO_METEO_EXPORT,
                    ),
                    Dataset(
                        2, "Rev. 2", "Cleaned mast shadow", 90.5,
                        datetime(2012, 12, 31), datetime(2019, 12, 31),
                        datetime(2023, 1, 6, 10, 0), "Mia Wong",
                        datetime(2023, 1, 6, 10, 0), "Mia Wong",
                        DataFormat.WINDPRO_METEO_EXPORT,
                    ),
                    Dataset(
                        3, "Rev. 3", "Add data from january 2020", 90.5,
                        datetime(2012, 12, 31), datetime(2020, 1, 31),
                        datetime(2023, 1, 7, 15, 0), "Ponnappa Priya",
                        datetime(2023, 1, 7, 15, 0), "Ponnappa Priya",
                        DataFormat.WINDPRO_METEO_EXPORT,
                    ),
                    Dataset(
                        4, "Rev. 4", "Add synthesized height", 120.0,
                        datetime(2012, 12, 31), datetime(2020, 1, 31),
                        datetime(2023, 2, 7, 9, 8), "Ang Li",
                        datetime(2023, 2, 7, 9, 8), "Ang Li",
                        DataFormat.WINDPRO_METEO_EXPORT,
                    ),
                ]
            ),
            Location(
                "Mast Strandby", 10.5, 57.49, 25.0,
                [
                    Dataset(
                        5, "Rev. 1", "Raw data", 88.80,
                        datetime(2012, 12, 31), datetime(2019, 12, 31),
                        datetime(2023, 1, 5, 13, 4), "peter@example.com",
                        datetime(2023, 1, 5, 13, 4), "peter@example.com",
                        DataFormat.WINDPRO_METEO_EXPORT,
                    ),
                    Dataset(
                        6, "Rev. 2", "Cleaned data", 88.80,
                        datetime(2012, 12, 31), datetime(2019, 12, 31),
                        datetime(2023, 1, 6, 10, 4), "peter@example.com",
                        datetime(2023, 1, 6, 10, 4), "peter@example.com",
                        DataFormat.WINDPRO_METEO_EXPORT,
                    ),
                ]
            ),
        ]),
    Project(
        'Project B',
        [
            Location(
                "Lidar Viborg", 9.4, 56.45, 15.0,
                [
                    Dataset(
                        7, "Rev. 1", "Raw data (mesores format)", 250.0,
                        datetime(2020, 1, 1), datetime(2020, 12, 31),
                        datetime(2021, 11, 15, 10, 49), "natalie@example.com",
                        datetime(2021, 11, 15, 10, 49), "natalie@example.com",
                        DataFormat.WINDPRO_MESORES,
                    ),
                ]
            ),
            Location(
                "Lidar Aars", 9.5, 56.80, 15.0,
                [
                    Dataset(
                        8, "Rev. 1", "Raw data", 250.0,
                        datetime(2020, 1, 1), datetime(2020, 12, 31),
                        datetime(2021, 11, 15, 10, 49), "natalie@example.com",
                        datetime(2021, 11, 15, 10, 49), "natalie@example.com",
                        DataFormat.WINDPRO_MESORES,
                    ),
                ]
            ),
            Location(
                "Lidar Hobro", 9.8, 56.65, 15.0,
                [
                    Dataset(
                        9, "Rev. 1", "Raw data 123 æøå 한글 😁", 250.0,
                        datetime(2020, 1, 1), datetime(2020, 12, 31),
                        datetime(2021, 11, 15, 10, 49), "natalie@example.com",
                        datetime(2021, 11, 15, 10, 49), "natalie@example.com",
                        DataFormat.WINDPRO_MESORES,
                    ),
                ]
            ),
        ]
    ),
    Project(
        'Project C',
        [
            Location(
                "Mast Aabybro", 9.78, 57.205, 11.0,
                [
                    Dataset(
                        10, "Rev. 1", "Raw data (plaintext timeseries data)", 70.0,
                        datetime(2010, 1, 1), datetime(2011, 12, 31),
                        datetime(2022, 12, 13, 10, 49), "natalie@example.com",
                        datetime(2023, 1, 29, 13, 8), "natalie@example.com",
                        DataFormat.PLAINTEXT_TIMESERIES_DATA,
                    ),
                ]
            )
        ]
    ),
]
