from rest_framework import serializers


class IntegerSerializer(serializers.Serializer):

    def to_representation(self, value):
        # Serializers normally return an object, but here we return a primitive value instead
        return value


class DatasetSerializer(serializers.Serializer):
    id = serializers.IntegerField()
    name = serializers.CharField()
    description = serializers.CharField()
    main_height = serializers.FloatField()
    first_sample = serializers.DateTimeField()
    last_sample = serializers.DateTimeField()
    created = serializers.DateTimeField()
    created_by = serializers.CharField()
    modified = serializers.DateTimeField()
    modified_by = serializers.CharField()
    data_format = serializers.CharField()


class LocationSerializer(serializers.Serializer):
    name = serializers.CharField()
    lon = serializers.FloatField()
    lat = serializers.FloatField()
    elevation = serializers.FloatField()
    datasets = DatasetSerializer(many=True)


class ProjectSerializer(serializers.Serializer):
    name = serializers.CharField()
    locations = LocationSerializer(many=True)
